Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | Friends | List of all members
GraphicsWindow Class Reference

A window, fullscreen or on a desktop, into which a graphics device sends its output for interactive display. More...

`#include "graphicsWindow.h"`

Inheritance diagram for GraphicsWindow:

## Public Member Functions
virtual void | add_window_proc (const GraphicsWindowProc *wnd_proc_object)
void | clear_rejected_properties ()
| Empties the set of failed properties that will be returned by get_rejected_properties().
virtual void | clear_window_procs ()
virtual void | close_ime ()
| Forces the ime window to close if any.
void | disable_pointer_events (int device)
| Turn off the generation of pointer events.
void | enable_pointer_events (int device)
| Turn on the generation of pointer events.
virtual TypeHandle | force_init_type ()
std::string | get_close_request_event () const
InputDevice * | get_input_device (int i) const
std::string | get_input_device_name (int device) const
virtual ButtonMap * | get_keyboard_map () const
| Returns a ButtonMap containing the association between raw buttons and virtual buttons.
int | get_num_input_devices () const
virtual int | get_num_touches ()
| Returns the current number of touches on this window.
virtual MouseData | get_pointer (int device) const
| See GraphicsWindowInputDevice::enable_pointer_mode.
const WindowProperties | get_properties () const
WindowProperties | get_rejected_properties () const
const WindowProperties | get_requested_properties () const
virtual TouchInfo | get_touch_info (int index)
| Returns the TouchInfo object describing the specified touch.
virtual TypeHandle | get_type () const
bool | get_unexposed_draw () const
std::string | get_window_event () const
WindowHandle * | get_window_handle () const
bool | has_keyboard (int device) const
| Returns true if the nth input device has a keyboard, false otherwise.
bool | has_pointer (int device) const
| Returns true if the nth input device has a screen-space pointer (for instance, a mouse), false otherwise.
virtual bool | is_active () const
| Returns true if the window is ready to be rendered into, false otherwise.
bool | is_closed () const
bool | is_fullscreen () const
| Returns true if the window has been opened as a fullscreen window, false otherwise.
virtual bool | is_touch_event (GraphicsWindowProcCallbackData *callbackData)
| Returns whether the specified event msg is a touch message.
virtual bool | move_pointer (int device, int x, int y)
| Forces the pointer to the indicated position within the window, if possible.
virtual void | process_events ()
| Do whatever processing is necessary to ensure that the window responds to user events.
virtual void | remove_window_proc (const GraphicsWindowProc *wnd_proc_object)
virtual void | request_close ()
| This is called by the GraphicsEngine to request that the window (or whatever) close itself or, in general, make itself invalid, at the next call to process_events().
virtual void | request_open ()
| This is called by the GraphicsEngine to request that the window (or whatever) open itself or, in general, make itself valid, at the next call to process_events().
void | request_properties (const WindowProperties &requested_properties)
| Requests a property change on the window.
virtual void | set_close_now ()
| This is called by the GraphicsEngine to insist that the window be closed immediately.
void | set_close_request_event (const std::string &close_request_event)
virtual void | set_properties_now (WindowProperties &properties)
| Applies the requested set of properties to the window, if possible, for instance to request a change in size or minimization status.
void | set_unexposed_draw (bool unexposed_draw)
void | set_window_event (const std::string &window_event)
virtual bool | supports_window_procs () const
| Returns whether this window supports adding of Windows proc handlers.
virtual int | verify_window_sizes (int numsizes, int *dimen)
| Determines which of the indicated window sizes are supported by available hardware (e.g.
Public Member Functions inherited from GraphicsOutput
void | add_render_texture (Texture *tex, RenderTextureMode mode, RenderTexturePlane bitplane=RTP_COUNT)
| Creates a new Texture object, suitable for rendering the contents of this buffer into, and appends it to the list of render textures.
virtual void | begin_flip ()
| This function will be called within the draw thread after end_frame() has been called on all windows, to initiate the exchange of the front and back buffers.
virtual bool | begin_frame (FrameMode mode, Thread *current_thread)
| This function will be called within the draw thread before beginning rendering for a given frame.
void | change_scenes (DisplayRegionPipelineReader *new_dr)
| Called by the GraphicsEngine when the window is about to change to another DisplayRegion.
virtual void | clear (Thread *current_thread)
| Clears the entire framebuffer before rendering, according to the settings of get_color_clear_active() and get_depth_clear_active() (inherited from DrawableRegion).
void | clear_child_sort ()
| Resets the sort value of future offscreen buffers created by make_texture_sort() to the default value.
void | clear_delete_flag ()
| Resets the delete flag, so the GraphicsOutput will not be automatically deleted before the beginning of the next frame.
virtual void | clear_pipe ()
| Sets the window's _pipe pointer to NULL; this is generally called only as a precursor to deleting the window.
void | clear_render_textures ()
| If the GraphicsOutput is currently rendering to a texture, then all textures are dissociated from the GraphicsOuput.
int | count_textures () const
| If the GraphicsOutput is set to render into a texture, returns the number of textures that are being rendered into.
virtual void | end_flip ()
| This function will be called within the draw thread after begin_flip() has been called on all windows, to finish the exchange of the front and back buffers.
virtual void | end_frame (FrameMode mode, Thread *current_thread)
| This function will be called within the draw thread after rendering is completed for a given frame.
virtual bool | flip_ready () const
| Returns true if a frame has been rendered and needs to be flipped, false otherwise.
PointerTo< DisplayRegion > | get_active_display_region (int n) const
int | get_child_sort () const
PStatCollector & | get_clear_window_pcollector ()
| Returns a PStatCollector for timing the clear operation for just this GraphicsOutput.
PStatCollector & | get_cull_window_pcollector ()
| Returns a PStatCollector for timing the cull operation for just this GraphicsOutput.
bool | get_delete_flag () const
| Returns the current setting of the delete flag.
PointerTo< DisplayRegion > | get_display_region (int n) const
PStatCollector & | get_draw_window_pcollector ()
| Returns a PStatCollector for timing the draw operation for just this GraphicsOutput.
GraphicsEngine * | get_engine () const
const FrameBufferProperties & | get_fb_properties () const
| Returns the framebuffer properties of the window.
LVecBase2i | get_fb_size () const
int | get_fb_x_size () const
| Returns the internal width of the window or buffer.
int | get_fb_y_size () const
| Returns the internal height of the window or buffer.
GraphicsStateGuardian * | get_gsg () const
virtual GraphicsOutput * | get_host ()
| This is normally called only from within make_texture_buffer().
bool | get_inverted () const
unsigned int | get_left_eye_color_mask () const
| Returns the color mask in effect when rendering a left-eye view in red_blue stereo mode.
const std::string & | get_name () const
int | get_num_active_display_regions () const
int | get_num_display_regions () const
bool | get_one_shot () const
DisplayRegion * | get_overlay_display_region () const
| Returns the special "overlay" DisplayRegion that is created for each window or buffer.
GraphicsPipe * | get_pipe () const
bool | get_red_blue_stereo () const
| Returns whether red-blue stereo mode is in effect for this particular window.
unsigned int | get_right_eye_color_mask () const
| Returns the color mask in effect when rendering a right-eye view in red_blue stereo mode.
RenderTextureMode | get_rtm_mode (int i=0) const
| Returns the RenderTextureMode associated with the nth render-texture.
const LVecBase4 & | get_sbs_left_dimensions () const
| Returns the effective sub-region of the window for displaying the left channel, if side-by-side stereo mode is in effect for the window.
LVecBase2i | get_sbs_left_size () const
int | get_sbs_left_x_size () const
| If side-by-side stereo is enabled, this returns the pixel width of the left eye, based on scaling get_x_size() by get_sbs_left_dimensions().
int | get_sbs_left_y_size () const
| If side-by-side stereo is enabled, this returns the pixel height of the left eye, based on scaling get_y_size() by get_sbs_left_dimensions().
const LVecBase4 & | get_sbs_right_dimensions () const
| Returns the effective sub-region of the window for displaying the right channel, if side-by-side stereo mode is in effect for the window.
LVecBase2i | get_sbs_right_size () const
int | get_sbs_right_x_size () const
| If side-by-side stereo is enabled, this returns the pixel width of the right eye, based on scaling get_x_size() by get_sbs_right_dimensions().
int | get_sbs_right_y_size () const
| If side-by-side stereo is enabled, this returns the pixel height of the right eye, based on scaling get_y_size() by get_sbs_right_dimensions().
PointerTo< Texture > | get_screenshot ()
bool | get_screenshot (PNMImage &image)
| Captures the most-recently rendered image from the framebuffer into the indicated PNMImage.
bool | get_side_by_side_stereo () const
| Returns whether side-by-side stereo mode is in effect for this particular window.
const LVecBase2i & | get_size () const
int | get_sort () const
virtual bool | get_supports_render_texture () const
bool | get_swap_eyes () const
virtual Texture * | get_texture (int i=0) const
| Returns the nth texture into which the GraphicsOutput renders.
NodePath | get_texture_card ()
| Returns a PandaNode containing a square polygon.
RenderTexturePlane | get_texture_plane (int i=0) const
| Returns the RenderTexturePlane associated with the nth render-texture.
int | get_x_size () const
| Returns the visible width of the window or buffer, if it is known.
int | get_y_size () const
| Returns the visible height of the window or buffer, if it is known.
bool | has_size () const
| Returns true if the size of the window/frame buffer is known, false otherwise.
bool | has_texture () const
| Returns true if the GraphicsOutput is rendering into any textures at all.
bool | is_nonzero_size () const
| Returns true if the output has a nonzero size in both X and Y, or false if it is zero (and therefore invalid).
bool | is_stereo () const
| Returns Returns true if this window can render stereo DisplayRegions, either through red-blue stereo (see set_red_blue_stereo()) or through true hardware stereo rendering.
bool | is_valid () const
| Returns true if the output is fully created and ready for rendering, false otherwise.
GraphicsOutput * | make_cube_map (const std::string &name, int size, NodePath &camera_rig, DrawMask camera_mask=PandaNode::get_all_camera_mask(), bool to_ram=false, FrameBufferProperties *fbp=nullptr)
| This is similar to make_texture_buffer() in that it allocates a separate buffer suitable for rendering to a texture that can be assigned to geometry in this window, but in this case, the buffer is set up to render the six faces of a cube map.
DisplayRegion * | make_display_region ()
| Creates a new DisplayRegion that covers the entire window.
DisplayRegion * | make_display_region (const LVecBase4 &dimensions)
| Creates a new DisplayRegion that covers the indicated sub-rectangle within the window.
DisplayRegion * | make_display_region (PN_stdfloat l, PN_stdfloat r, PN_stdfloat b, PN_stdfloat t)
| Creates a new DisplayRegion that covers the indicated sub-rectangle within the window.
DisplayRegion * | make_mono_display_region ()
| Creates a new DisplayRegion that covers the entire window.
DisplayRegion * | make_mono_display_region (const LVecBase4 &dimensions)
| Creates a new DisplayRegion that covers the indicated sub-rectangle within the window.
DisplayRegion * | make_mono_display_region (PN_stdfloat l, PN_stdfloat r, PN_stdfloat b, PN_stdfloat t)
| Creates a new DisplayRegion that covers the entire window.
StereoDisplayRegion * | make_stereo_display_region ()
| Creates a new DisplayRegion that covers the entire window.
StereoDisplayRegion * | make_stereo_display_region (const LVecBase4 &dimensions)
| Creates a new DisplayRegion that covers the indicated sub-rectangle within the window.
StereoDisplayRegion * | make_stereo_display_region (PN_stdfloat l, PN_stdfloat r, PN_stdfloat b, PN_stdfloat t)
| Creates a new DisplayRegion that covers the entire window.
GraphicsOutput * | make_texture_buffer (const std::string &name, int x_size, int y_size, Texture *tex=nullptr, bool to_ram=false, FrameBufferProperties *fbp=nullptr)
| Creates and returns an offscreen buffer for rendering into, the result of which will be a texture suitable for applying to geometry within the scene rendered into this window.
bool | operator< (const GraphicsOutput &other) const
| The sorting operator is used to order the GraphicsOutput object in order by their sort number, so that they will render in the correct order in the GraphicsEngine.
virtual void | ready_flip ()
| This function will be called within the draw thread after end_frame() has been called on all windows, to initiate the exchange of the front and back buffers.
void | remove_all_display_regions ()
| Removes all display regions from the window, except the default one that is created with the window.
bool | remove_display_region (DisplayRegion *display_region)
| Removes the indicated DisplayRegion from the window, and destructs it if there are no other references.
bool | save_screenshot (const Filename &filename, const std::string &image_comment="")
| Saves a screenshot of the region to the indicated filename.
Filename | save_screenshot_default (const std::string &prefix="screenshot")
| Saves a screenshot of the region to a default filename, and returns the filename, or empty string if the screenshot failed.
virtual void | select_target_tex_page (int page)
| Called internally when the window is in render-to-a-texture mode and we are in the process of rendering the six faces of a cube map, or any other multi-page texture.
void | set_active (bool active)
void | set_child_sort (int child_sort)
void | set_inverted (bool inverted)
void | set_one_shot (bool one_shot)
void | set_overlay_display_region (DisplayRegion *display_region)
| Replaces the special "overlay" DisplayRegion that is created for each window or buffer.
void | set_red_blue_stereo (bool red_blue_stereo, unsigned int left_eye_color_mask, unsigned int right_eye_color_mask)
| Enables red-blue stereo mode on this particular window.
void | set_side_by_side_stereo (bool side_by_side_stereo)
| Enables side-by-side stereo mode on this particular window.
void | set_side_by_side_stereo (bool side_by_side_stereo, const LVecBase4 &sbs_left_dimensions, const LVecBase4 &sbs_right_dimensions)
| Enables side-by-side stereo mode on this particular window.
void | set_size_and_recalc (int x, int y)
| Changes the x_size and y_size, then recalculates structures that depend on size.
virtual void | set_sort (int sort)
void | set_swap_eyes (bool swap_eyes)
void | setup_render_texture (Texture *tex, bool allow_bind, bool to_ram)
| This is a deprecated interface that made sense back when GraphicsOutputs could only render into one texture at a time.
virtual bool | share_depth_buffer (GraphicsOutput *graphics_output)
| Will attempt to use the depth buffer of the input graphics_output.
AsyncFuture * | trigger_copy ()
| When the GraphicsOutput is in triggered copy mode, this function triggers the copy (at the end of the next frame).
virtual void | unshare_depth_buffer ()
| Discontinue sharing the depth buffer.
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type.
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
virtual int | complete_pointers (TypedWritable **p_list, BamReader *manager)
| Receives an array of pointers, one for each time manager->read_pointer() was called in fillin().
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object.
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string.
virtual void | fillin (DatagramIterator &scan, BamReader *manager)
| This internal function is intended to be called by each class's make_from_bam() method to read in all of the relevant data from the BamFile for the new object.
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed.
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter.
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams.
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed.
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates.
virtual void | write_datagram (BamWriter *manager, Datagram &dg)
| Writes the contents of this object to the datagram for shipping out to a Bam file.
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.
Public Member Functions inherited from DrawableRegion
| DrawableRegion (const DrawableRegion &copy)
void | copy_clear_settings (const DrawableRegion &copy)
| Copies only the clear settings from the other drawable region.
virtual void | disable_clears ()
| Disables both the color and depth clear.
virtual bool | get_clear_active (int n) const
| Gets the clear-active flag for any bitplane.
const LColor & | get_clear_color () const
bool | get_clear_color_active () const
| Returns the current setting of the flag that indicates whether the color buffer should be cleared every frame.
PN_stdfloat | get_clear_depth () const
bool | get_clear_depth_active () const
| Returns the current setting of the flag that indicates whether the depth buffer should be cleared every frame.
unsigned int | get_clear_stencil () const
bool | get_clear_stencil_active () const
| Returns the current setting of the flag that indicates whether the color buffer should be cleared every frame.
virtual const LColor & | get_clear_value (int n) const
| Returns the clear value for any bitplane.
int | get_draw_buffer_type () const
| Returns the RenderBuffer into which the GSG should issue draw commands.
PN_stdfloat | get_pixel_factor () const
PN_stdfloat | get_pixel_zoom () const
int | get_screenshot_buffer_type () const
| Returns the RenderBuffer that should be used for capturing screenshots from this particular DrawableRegion.
virtual bool | is_any_clear_active () const
| Returns true if any of the clear types (so far there are just color or depth) have been set active, or false if none of them are active and there is no need to clear.
void | operator= (const DrawableRegion &copy)
virtual void | set_clear_active (int n, bool clear_aux_active)
| Sets the clear-active flag for any bitplane.
void | set_clear_color (const LColor &color)
void | set_clear_color_active (bool clear_color_active)
| Toggles the flag that indicates whether the color buffer should be cleared every frame.
void | set_clear_depth (PN_stdfloat depth)
void | set_clear_depth_active (bool clear_depth_active)
| Toggles the flag that indicates whether the depth buffer should be cleared every frame.
void | set_clear_stencil (unsigned int stencil)
void | set_clear_stencil_active (bool clear_stencil_active)
| Toggles the flag that indicates whether the stencil buffer should be cleared every frame.
virtual void | set_clear_value (int n, const LColor &clear_value)
| Sets the clear value for any bitplane.
virtual void | set_pixel_zoom (PN_stdfloat pixel_zoom)
virtual bool | supports_pixel_zoom () const
| Returns true if a call to set_pixel_zoom() will be respected, false if it will be ignored.

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from GraphicsOutput
static TypeHandle | get_class_type ()
static void | init_type ()
static Filename | make_screenshot_filename (const std::string &prefix="screenshot")
| Saves a screenshot of the region to a default filename, and returns the filename, or empty string if the screenshot failed.
Static Public Member Functions inherited from GraphicsOutputBase
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes.
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from DrawableRegion
static int | get_renderbuffer_type (int plane)
| Returns the RenderBuffer::Type that corresponds to a RenderTexturePlane.

## Public Attributes
| get_close_request_event
| Returns the name of the event set via set_close_request_event().
| get_input_device
| Returns the nth input device associated with the window.
| get_input_device_name
| Returns the name of the nth input device.
| get_num_input_devices
| Returns the number of separate input devices associated with the window.
| get_properties
| Returns the current properties of the window.
| get_rejected_properties
| Returns the set of properties that have recently been requested, but could not be applied to the window for some reason.
| get_requested_properties
| Returns the properties of the window that are currently requested.
| get_unexposed_draw
| See set_unexposed_draw().
| get_window_event
| Returns the name of the event that is generated when this window is modified externally, e.g.
| get_window_handle
| Returns the WindowHandle corresponding to this window on the desktop.
| is_closed
| Returns true if the window has not yet been opened, or has been fully closed, false if it is open.
| set_close_request_event
| Sets the event that is triggered when the user requests to close the window, e.g.
| set_unexposed_draw
| If this flag is false, the window is redrawn only after it has received a recent "unexpose" or "draw" event from the underlying windowing system.
| set_window_event
| Changes the name of the event that is generated when this window is modified externally, e.g.
Public Attributes inherited from GraphicsOutput
| get_active_display_region
| Returns the nth active DisplayRegion of those that have been created within the window.
| get_child_sort
| Returns the sort value of future offscreen buffers created by make_texture_sort().
| get_display_region
| Returns the nth DisplayRegion of those that have been created within the window.
| get_engine
| Returns the graphics engine that created this output.
| get_fb_size
| Returns the internal size of the window or buffer.
| get_gsg
| Returns the GSG that is associated with this window.
| get_inverted
| Returns the current setting of the inverted flag.
| get_name
| Returns the name that was passed to the GraphicsOutput constructor.
| get_num_active_display_regions
| Returns the number of active DisplayRegions that have been created within the window.
| get_num_display_regions
| Returns the number of DisplayRegions that have been created within the window, active or otherwise.
| get_one_shot
| Returns the current setting of the one-shot flag.
| get_pipe
| Returns the GraphicsPipe that this window is associated with.
| get_sbs_left_size
| If side-by-side stereo is enabled, this returns the pixel size of the left eye, based on scaling get_size() by get_sbs_left_dimensions().
| get_sbs_right_size
| If side-by-side stereo is enabled, this returns the pixel size of the right eye, based on scaling get_size() by get_sbs_right_dimensions().
| get_size
| Returns the visible size of the window or buffer, if it is known.
| get_sort
| Returns the sorting order of this particular GraphicsOutput.
| get_supports_render_texture
| Returns true if this particular GraphicsOutput can render directly into a texture, or false if it must always copy-to-texture at the end of each frame to achieve this effect.
| get_swap_eyes
| Returns the current setting of the "swap eyes" flag.
| is_active
| Returns true if the window is ready to be rendered into, false otherwise.
| set_active
| Sets the active flag associated with the GraphicsOutput.
| set_child_sort
| Specifies the sort value of future offscreen buffers created by make_texture_sort().
| set_inverted
| Changes the current setting of the inverted flag.
| set_one_shot
| Changes the current setting of the one-shot flag.
| set_sort
| Adjusts the sorting order of this particular GraphicsOutput, relative to other GraphicsOutputs.
| set_swap_eyes
| Changes the "swap eyes" flag.
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.
Public Attributes inherited from DrawableRegion
| get_clear_color
| Returns the current clear color value.
| get_clear_depth
| Returns the current clear depth value.
| get_clear_stencil
| Returns the current clear stencil value.
| get_pixel_factor
| Returns the amount by which the height and width of the region will be scaled internally, based on the zoom factor set by set_pixel_zoom().
| get_pixel_zoom
| Returns the value set by set_pixel_zoom(), regardless of whether it is being respected or not.
| set_clear_color
| Sets the clear color to the indicated value.
| set_clear_depth
| Sets the clear depth to the indicated value.
| set_clear_stencil
| Sets the clear stencil to the indicated value.
| set_pixel_zoom
| Sets the amount by which the pixels of the region are scaled internally when filling the image interally.

## Friends
class | Extension< GraphicsWindow >
class | GraphicsEngine

## Additional Inherited Members
Public Types inherited from GraphicsOutput
enum | FrameMode { FM_render , FM_parasite , FM_refresh }
enum | RenderTextureMode { RTM_none , RTM_bind_or_copy , RTM_copy_texture , RTM_copy_ram , RTM_triggered_copy_texture , RTM_triggered_copy_ram , RTM_bind_layered }
Public Types inherited from DrawableRegion
enum | RenderTexturePlane { RTP_stencil =0 , RTP_depth_stencil =1 , RTP_color , RTP_aux_rgba_0 , RTP_aux_rgba_1 , RTP_aux_rgba_2 , RTP_aux_rgba_3 , RTP_aux_hrgba_0 , RTP_aux_hrgba_1 , RTP_aux_hrgba_2 , RTP_aux_hrgba_3 , RTP_aux_float_0 , RTP_aux_float_1 , RTP_aux_float_2 , RTP_aux_float_3 , RTP_depth , RTP_COUNT }
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

A window, fullscreen or on a desktop, into which a graphics device sends its output for interactive display.

Definition at line 40 of file graphicsWindow.h.

## Constructor & Destructor Documentation

## ◆ ~GraphicsWindow()

GraphicsWindow::~GraphicsWindow | ( |  | ) |
| virtual

Definition at line 71 of file graphicsWindow.cxx.

## Member Function Documentation

## ◆ add_window_proc()

virtual void GraphicsWindow::add_window_proc | ( | const GraphicsWindowProc * | wnd_proc_object | ) |
| inline virtual

Reimplemented in WinGraphicsWindow.

Definition at line 103 of file graphicsWindow.h.

## ◆ clear_rejected_properties()

void GraphicsWindow::clear_rejected_properties | ( |  | ) |

Empties the set of failed properties that will be returned by get_rejected_properties().

Definition at line 116 of file graphicsWindow.cxx.

## ◆ clear_window_procs()

virtual void GraphicsWindow::clear_window_procs | ( |  | ) |
| inline virtual

Reimplemented in WinGraphicsWindow.

Definition at line 105 of file graphicsWindow.h.

## ◆ close_ime()

void GraphicsWindow::close_ime | ( |  | ) |
| virtual

Forces the ime window to close if any.

Reimplemented in WinGraphicsWindow.

Definition at line 388 of file graphicsWindow.cxx.

## ◆ disable_pointer_events()

void GraphicsWindow::disable_pointer_events | ( | int | device | ) |

Turn off the generation of pointer events.

Definition at line 326 of file graphicsWindow.cxx.

## ◆ enable_pointer_events()

void GraphicsWindow::enable_pointer_events | ( | int | device | ) |

Turn on the generation of pointer events.

Definition at line 316 of file graphicsWindow.cxx.

## ◆ force_init_type()

virtual TypeHandle GraphicsWindow::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from GraphicsOutput.

Definition at line 181 of file graphicsWindow.h.

## ◆ get_class_type()

static TypeHandle GraphicsWindow::get_class_type | ( |  | ) |
| inline static

Definition at line 170 of file graphicsWindow.h.

## ◆ get_keyboard_map()

ButtonMap * GraphicsWindow::get_keyboard_map | ( |  | ) | const
| virtual

Returns a ButtonMap containing the association between raw buttons and virtual buttons.

Reimplemented in CocoaGraphicsWindow.

Definition at line 308 of file graphicsWindow.cxx.

## ◆ get_num_touches()

int GraphicsWindow::get_num_touches | ( |  | ) |
| virtual

Returns the current number of touches on this window.

Reimplemented in WinGraphicsWindow.

Definition at line 728 of file graphicsWindow.cxx.

## ◆ get_pointer()

MouseData GraphicsWindow::get_pointer | ( | int | device | ) | const
| virtual

See GraphicsWindowInputDevice::enable_pointer_mode.

See GraphicsWindowInputDevice::disable_pointer_mode

Returns the MouseData associated with the nth input device's pointer. Using this to access raw mice (with an index other than 0) is deprecated, see the InputDeviceManager interface instead.

Reimplemented in WinGraphicsWindow, and x11GraphicsWindow.

Definition at line 360 of file graphicsWindow.cxx.

References MouseData.

## ◆ get_touch_info()

TouchInfo GraphicsWindow::get_touch_info | ( | int | index | ) |
| virtual

Returns the TouchInfo object describing the specified touch.

Reimplemented in WinGraphicsWindow.

Definition at line 737 of file graphicsWindow.cxx.

## ◆ get_type()

virtual TypeHandle GraphicsWindow::get_type | ( |  | ) | const
| inline virtual

Reimplemented from GraphicsOutput.

Definition at line 178 of file graphicsWindow.h.

## ◆ has_keyboard()

bool GraphicsWindow::has_keyboard | ( | int | device | ) | const

Returns true if the nth input device has a keyboard, false otherwise.

Definition at line 293 of file graphicsWindow.cxx.

## ◆ has_pointer()

bool GraphicsWindow::has_pointer | ( | int | device | ) | const

Returns true if the nth input device has a screen-space pointer (for instance, a mouse), false otherwise.

Definition at line 279 of file graphicsWindow.cxx.

## ◆ init_type()

static void GraphicsWindow::init_type | ( |  | ) |
| inline static

Definition at line 173 of file graphicsWindow.h.

## ◆ is_active()

bool GraphicsWindow::is_active | ( |  | ) | const
| virtual

Returns true if the window is ready to be rendered into, false otherwise.

Reimplemented from GraphicsOutput.

Definition at line 165 of file graphicsWindow.cxx.

References GraphicsOutput::is_active.

Referenced by wdxGraphicsWindow9::end_flip().

## ◆ is_fullscreen()

bool GraphicsWindow::is_fullscreen | ( |  | ) | const
| inline

Returns true if the window has been opened as a fullscreen window, false otherwise.

Definition at line 30 of file graphicsWindow.I.

Referenced by set_properties_now(), WinGraphicsWindow::set_properties_now(), x11GraphicsWindow::set_properties_now(), and WinGraphicsWindow::window_proc().

## ◆ is_touch_event()

bool GraphicsWindow::is_touch_event | ( | GraphicsWindowProcCallbackData * | callbackData | ) |
| virtual

Returns whether the specified event msg is a touch message.

Reimplemented in WinGraphicsWindow.

Definition at line 719 of file graphicsWindow.cxx.

## ◆ move_pointer()

bool GraphicsWindow::move_pointer | ( | int | device,
|  | int | x,
|  | int | y )
| virtual

Forces the pointer to the indicated position within the window, if possible.

Returns true if successful, false on failure. This may fail if the mouse is not currently within the window, or if the API doesn't support this operation.

Reimplemented in CocoaGraphicsWindow, osxGraphicsWindow, WinGraphicsWindow, and x11GraphicsWindow.

Definition at line 379 of file graphicsWindow.cxx.

## ◆ process_events()

void GraphicsWindow::process_events | ( |  | ) |
| virtual

Do whatever processing is necessary to ensure that the window responds to user events.

Also, honor any requests recently made via request_properties().

This function is called only within the window thread.

Reimplemented from GraphicsOutput.

Reimplemented in AndroidGraphicsWindow, CallbackGraphicsWindow, CocoaGraphicsWindow, IPhoneGraphicsWindow, osxGraphicsWindow, WinGraphicsWindow, and x11GraphicsWindow.

Definition at line 458 of file graphicsWindow.cxx.

References WindowProperties::add_properties(), WindowProperties::clear(), WindowProperties::is_any_specified(), and set_properties_now().

Referenced by AndroidGraphicsWindow::process_events(), CallbackGraphicsWindow::process_events(), WinGraphicsWindow::process_events(), and x11GraphicsWindow::process_events().

## ◆ remove_window_proc()

virtual void GraphicsWindow::remove_window_proc | ( | const GraphicsWindowProc * | wnd_proc_object | ) |
| inline virtual

Reimplemented in WinGraphicsWindow.

Definition at line 104 of file graphicsWindow.h.

## ◆ request_close()

void GraphicsWindow::request_close | ( |  | ) |
| virtual

This is called by the GraphicsEngine to request that the window (or whatever) close itself or, in general, make itself invalid, at the next call to process_events().

By that time we promise the gsg pointer will be cleared.

Reimplemented from GraphicsOutput.

Definition at line 433 of file graphicsWindow.cxx.

References request_properties(), and WindowProperties::set_open.

## ◆ request_open()

void GraphicsWindow::request_open | ( |  | ) |
| virtual

This is called by the GraphicsEngine to request that the window (or whatever) open itself or, in general, make itself valid, at the next call to process_events().

Reimplemented from GraphicsOutput.

Definition at line 420 of file graphicsWindow.cxx.

References request_properties(), and WindowProperties::set_open.

## ◆ request_properties()

void GraphicsWindow::request_properties | ( | const WindowProperties & | requested_properties | ) |

Requests a property change on the window.

For example, use this method to request a window change size or minimize or something.

The change is not made immediately; rather, the request is saved and will be applied the next time the window task is run (probably at the next frame).

Definition at line 146 of file graphicsWindow.cxx.

Referenced by request_close(), and request_open().

## ◆ set_close_now()

void GraphicsWindow::set_close_now | ( |  | ) |
| virtual

This is called by the GraphicsEngine to insist that the window be closed immediately.

This is only called from the window thread.

Reimplemented from GraphicsOutput.

Definition at line 444 of file graphicsWindow.cxx.

References WindowProperties::set_open, and set_properties_now().

## ◆ set_properties_now()

void GraphicsWindow::set_properties_now | ( | WindowProperties & | properties | ) |
| virtual

Applies the requested set of properties to the window, if possible, for instance to request a change in size or minimization status.

The window properties are applied immediately, rather than waiting until the next frame. This implies that this method may *only* be called from within the window thread.

The properties that have been applied are cleared from the structure by this function; so on return, whatever remains in the properties structure are those that were unchanged for some reason (probably because the underlying interface does not support changing that property on an open window).

Reimplemented in AndroidGraphicsWindow, CallbackGraphicsWindow, CocoaGraphicsWindow, IPhoneGraphicsWindow, osxGraphicsWindow, WinGraphicsWindow, and x11GraphicsWindow.

Definition at line 494 of file graphicsWindow.cxx.

References WindowProperties::clear(), WindowProperties::clear_fullscreen, WindowProperties::clear_mouse_mode, WindowProperties::clear_open, WindowProperties::clear_origin, WindowProperties::clear_size, WindowProperties::get_fullscreen, WindowProperties::get_mouse_mode, WindowProperties::get_open, WindowProperties::get_x_origin(), WindowProperties::get_x_size(), WindowProperties::get_y_origin(), WindowProperties::get_y_size(), WindowProperties::has_fullscreen, WindowProperties::has_open, WindowProperties::has_origin, WindowProperties::has_size, is_fullscreen(), WindowProperties::set_origin, WindowProperties::set_size, and GraphicsOutput::set_size_and_recalc().

Referenced by process_events(), set_close_now(), AndroidGraphicsWindow::set_properties_now(), CallbackGraphicsWindow::set_properties_now(), WinGraphicsWindow::set_properties_now(), and x11GraphicsWindow::set_properties_now().

## ◆ supports_window_procs()

bool GraphicsWindow::supports_window_procs | ( |  | ) | const
| virtual

Returns whether this window supports adding of Windows proc handlers.

Reimplemented in WinGraphicsWindow.

Definition at line 746 of file graphicsWindow.cxx.

## ◆ verify_window_sizes()

int GraphicsWindow::verify_window_sizes | ( | int | numsizes,
|  | int * | dimen )
| virtual

Determines which of the indicated window sizes are supported by available hardware (e.g.

in fullscreen mode).

On entry, dimen is an array containing contiguous x,y pairs specifying possible display sizes; it is numsizes*2 words long. The function will zero out any invalid x,y size pairs. The return value is the number of valid sizes that were found.

Note this doesn't guarantee a resize attempt will work; you still need to check the return value.

(It might be better to implement some sort of query interface that returns an array of supported sizes, but this way is somewhat simpler and will do the job on most cards, assuming they handle the std sizes the app knows about.)

Reimplemented in wdxGraphicsWindow9.

Definition at line 410 of file graphicsWindow.cxx.

## Friends And Related Symbol Documentation

## ◆ Extension< GraphicsWindow >

friend class Extension< GraphicsWindow >
| friend

Definition at line 186 of file graphicsWindow.h.

## ◆ GraphicsEngine

friend class GraphicsEngine
| friend

Definition at line 186 of file graphicsWindow.h.

## Member Data Documentation

## ◆ get_close_request_event

string GraphicsWindow::get_close_request_event

Returns the name of the event set via set_close_request_event().

If this string is nonempty, then when the user requests to close window, this event will be generated instead. See set_close_request_event().

Definition at line 74 of file graphicsWindow.h.

Referenced by x11GraphicsWindow::process_events(), and WinGraphicsWindow::window_proc().

## ◆ get_input_device

InputDevice * GraphicsWindow::get_input_device

Returns the nth input device associated with the window.

Typically, a window will have exactly one input device: the keyboard/mouse pair.

Definition at line 87 of file graphicsWindow.h.

Referenced by MouseAndKeyboard::set_source().

## ◆ get_input_device_name

string GraphicsWindow::get_input_device_name

Returns the name of the nth input device.

Definition at line 88 of file graphicsWindow.h.

## ◆ get_num_input_devices

int GraphicsWindow::get_num_input_devices

Returns the number of separate input devices associated with the window.

Typically, a window will have exactly one input device: the keyboard/mouse pair. However, some windows may have no input devices, and others may add additional devices, for instance for a joystick.

Definition at line 87 of file graphicsWindow.h.

## ◆ get_properties

const WindowProperties GraphicsWindow::get_properties

Returns the current properties of the window.

Definition at line 63 of file graphicsWindow.h.

## ◆ get_rejected_properties

WindowProperties GraphicsWindow::get_rejected_properties

Returns the set of properties that have recently been requested, but could not be applied to the window for some reason.

This set of properties will remain unchanged until they are changed by a new failed request, or clear_rejected_properties() is called.

Definition at line 65 of file graphicsWindow.h.

## ◆ get_requested_properties

const WindowProperties GraphicsWindow::get_requested_properties

Returns the properties of the window that are currently requested.

These properties will be applied to the window (if valid) at the next execution of process_events().

Definition at line 64 of file graphicsWindow.h.

## ◆ get_unexposed_draw

bool GraphicsWindow::get_unexposed_draw
| inline

See set_unexposed_draw().

Definition at line 78 of file graphicsWindow.h.

Referenced by wdxGraphicsWindow9::begin_frame(), and wglGraphicsWindow::begin_frame().

## ◆ get_window_event

string GraphicsWindow::get_window_event

Returns the name of the event that is generated when this window is modified externally, e.g.

to be resized or closed by the user. See set_window_event().

Definition at line 70 of file graphicsWindow.h.

## ◆ get_window_handle

WindowHandle * GraphicsWindow::get_window_handle
| inline

Returns the WindowHandle corresponding to this window on the desktop.

This is mainly useful for communicating with external libraries. Use window_handle->get_os_handle()->get_handle(), or window_handle->get_string_handle(), to get the actual OS-specific window handle object, whatever type that might be.

Definition at line 81 of file graphicsWindow.h.

## ◆ is_closed

bool GraphicsWindow::is_closed
| inline

Returns true if the window has not yet been opened, or has been fully closed, false if it is open.

The window is not opened immediately after GraphicsEngine::make_output() is called; nor is it closed immediately after GraphicsEngine::remove_window() is called. Either operation may take a frame or two.

Definition at line 66 of file graphicsWindow.h.

## ◆ set_close_request_event

void GraphicsWindow::set_close_request_event

Sets the event that is triggered when the user requests to close the window, e.g.

via alt-F4, or clicking on the close box.

The default for each window is for this event to be the empty string, which means the window-close request is handled immediately by Panda (and the window will be closed without the app getting a chance to intervene). If you set this to a nonempty string, then the window is not closed, but instead the event is thrown. It is then up to the app to respond appropriately, for instance by presenting an "are you sure?" dialog box, and eventually calling close_window() when the user is sure.

It is considered poor form to set this string and then not handle the event. This can frustrate the user by making it difficult for him to cleanly shut down the application (and may force the user to hard-kill the app, or reboot the machine).

Definition at line 74 of file graphicsWindow.h.

## ◆ set_unexposed_draw

void GraphicsWindow::set_unexposed_draw
| inline

If this flag is false, the window is redrawn only after it has received a recent "unexpose" or "draw" event from the underlying windowing system.

If this flag is true, the window is redrawn every frame regardless. Setting this false may prevent the window from redrawing unnecessarily when it is hidden, and may play nicer with other windows on the desktop, but may adversely affect frame rate even when the window is fully visible; setting it true will ensure that the window contents are always current.

Definition at line 78 of file graphicsWindow.h.

## ◆ set_window_event

void GraphicsWindow::set_window_event

Changes the name of the event that is generated when this window is modified externally, e.g.

to be resized or closed by the user.

By default, all windows have the same window event unless they are explicitly changed. When the event is generated, it includes one parameter: the window itself.

Definition at line 70 of file graphicsWindow.h.

The documentation for this class was generated from the following files:

- panda/src/display/graphicsWindow.h
- panda/src/display/graphicsWindow.cxx
- panda/src/display/graphicsWindow.I